class Suzu < RSpec::Core::Formatters::ProgressFormatter
  RSpec::Core::Formatters.register self, :example_passed, :example_pending, :example_failed

  VT100_COLOR_CODES = ((30..37).to_a + (90..97).to_a).freeze

  def initialize(output)
    @example_count = 0

    super
  end

  def example_passed(_example_notification)
    @output.print("\e[#{VT100_COLOR_CODES[@example_count % VT100_COLOR_CODES.count]}m.\e[m")

    @example_count += 1
  end

  def example_pending(_example_notification)
    @output.print("\e[#{VT100_COLOR_CODES[@example_count % VT100_COLOR_CODES.count]};43m*\e[m")

    @example_count += 1
  end

  def example_failed(_example_notification)
    @output.print("\e[#{VT100_COLOR_CODES[@example_count % VT100_COLOR_CODES.count]};41mF\e[m")

    @example_count += 1
  end
 end
